-- GLOBAL --
SAM = select(2, ...); 
-- MODULE --
local _G = getfenv(0);
setmetatable(SAM, {__index = _G});
setfenv(1, SAM);
---

--copied from AddonSpamFu by yoshimo. 
knownPrefixes = {
	["AlgalonObserver"] = "AlgalonObserver",
	["ArenaMaster"] = "Arena Master",
	["Armory"] = "Armory",
	["BeastTraining"] = "BeastTraining",
	["BigWigs"] = "BigWigs",
		["BWVB"] = "BigWigs", -- BigwWigs version query
		["BWVB2"] = "BigWigs", --BigWigs version query v2
		["BWVQ"] = "BigWigs", --BigWigs version query
		["BWVR"] = "BigWigs", --BigWigs version response
		["BWOOD"] = "BigWigs", ---BigWigs version broadcast
		["BWOOD3"] = "BigWigs3",
		["BWTIP"] = "BigWigs3",
		["BWVQ3"] = "BigWigs3",
		["BWVR3"] = "BigWigs3",
		["BWVRA3"] = "BigWigs3",
	["BossNotes"] = "Boss Notes",
	["BOSSTACTICS"] = "BossTactics",
	["CastCommLib"] = "CastCommLib",
	["Crafts"] = "Crafts",
	["DamageMeters"] = "DamageMeters",
	["DataStore"] = "DataStore",
		["DS_Cont"] = "DataStore",
		["DS_Craft"] = "DataStore",
		["DS_Inv"] = "DataStore",
		["DS_Mails"] = "DataStore",
	["Death_Tracker"] = "Death_Tracker",
	["DoIKnowYou"] = "DoIKnowYou",
	["EASYMOTHER"] = "EasyMother",
	["EnsidiaFails"] = "EnsidiaFails",
	["ForteWarlock"] = "ForteXorcist",
	["Gatherer"] = "Gatherer",
	["GUILDMAP"] = "GuildMap",
	["LibVersionCheck"] = "LibVersionCheck-1.0",
	["lugMD"] = "lugMD",
	["LootFilter"] ="LootFilter",
	["MageMajic"]  ="MageMajic",
	["MagicMarker"] = "MagicMarker",
	["MalygosFlamer"] = "MalygosFlamer",
		["MalygosFlamerVersion"] = "MalygosFlamer",
	["MultiBoxer"] = "MultiBoxer",
	["PetEmote"] = "PetEmote",
	["PreformAVEnabler"] = "PreformAVEnabler",
	["PartyCastingBars"] = "PartyCastingBars",
	["QuestAnnouncer"] = "QuestAnnouncer",
	["RAB/BT"] = "RABuffs",
		["RAB/BI"] = "RABuffs", 
		["RAB/BS"] = "RABuffs", 
		["RAB/RD"] = "RABuffs", 
		["RAB/RN"] = "RABuffs", 
		["RAB/RE"] = "RABuffs", 
		["RAB/RO"] = "RABuffs", 
		["RAB/RF"] = "RABuffs", 
		["RAB/BR"] = "RABuffs", 
		["RAB/V"]  = "RABuffs", 
		["RAB/VC"] = "RABuffs",  
	["RAIDMOBMARKER"] = "RaidMobMarker",
	["RAIDVOICE"] = "RaidVoice",
	["RankWatch"] = "RankWatch",
	["Recap"] = "Recap",
	["Rupture"] = "Rupture",
	["SimpleMD"] = "SimpleMD",
	["SmartRes"] = "SmartRes",
	["SMN"] = "SpamMeNot",
	["SorrenTimers"] = "SorrenTimers",
	["SRTI"] = "Simple Raid Target Icons",
	["SSPVP"] = "SSPVP",
	["VisualHeal"] = "VisualHeal",
	["X-Perl"] = "X-Perl",
		["X-PerlHeal"] = "X-Perl",
	["XChar"] = "XChar-Profiler",
	["Yacl"] = "YACL-DmgMeter",
	
	["[HA]"] = "HealAssign",
	["D?"] = "ControlArena",
	["BGGQ"] = "Gladiator",
	["^RX^"] = "Prescription_Pickup",
	["AGC"] = "AthenesGearCheck",
	["ALF_T"] = "Arena Live Frames",
	["AltoGuild"] = "Altoholic",
		["Altoholic"] = "Altoholic",
	["AM_FU"] = "AlphaMap",
	["ATF"] = "AutoFIR",
		["ATf"] = "AutoFIR",
		["ATm"] = "AutoFIR",
	["ArenaUnitFrames"] = "Arena Unit Frames",
	["ATR"] = "Auctionator",
	["Audio Effects"] = "AFX",
	["AucAdvAskPrice"] = "Auctioneer",
	["BangCore_TPO"] = "Bang!Core",
	["BangWG5"] = "BangWintergrasp",
	["BEJEWELED2"] = "Bejeweled",
	["BEJ2a"] = "Bejeweled",
	["BE2"] = "BossEncounter2",
	["BFC"] = "Battlefield Commander",
	["BrokerEpicAvg"] = "Broker:EpicAvg",
	["BST"] = "Bonstar",
	["cap"] = "Capping",
	["Cap"] = "Capping_v3.2.002+",--new IoC siege sync
	["chatmod"] = "ChatMOD",
	["CKICK_SYNC"] = "Ckick", 
	["Crb"] = "CarboniteQuest",
	["CTRA"] = "CTRaidAssist",
	["CFUVCQ"] ="FuBar_ConvergeFU",
		["CFUVCR"] ="FuBar_ConvergeFU",   
	["CT3"] = "Cartographer 3",
	["DTMR"] = "DoTimer",
	["DBM3Alterac"] = "DeadlyBossMods_V3",
	["DBMv4-CombatInfo"] = "DeadlyBossMods_V4",
	["DBMv4-Kill"] = "DeadlyBossMods_V4",
	["DBMv4-Mod"] = "DeadlyBossMods_V4",
	["DBMv4-Pull"] = "DeadlyBossMods_V4",
	["DBMv4-Pizza"] = "DeadlyBossMods_V4",
	["DBMv4-RequestTimers"] = "DeadlyBossMods_V4",
	["DBMv4-TimerInfo"] = "DeadlyBossMods_V4",
	["DBMv4-Ver"] = "DeadlyBossMods_V4",
 	["dgks_txt"] = "dG Killshot Notifier",
		["dgks_ScrollingTextEvent"] = "dG Killshot Notifier",
		["dgks_KilledSoundEvent"] = "dG Killshot Notifier",
		["dgks_BGVersionCheckRequest"] = "dG Killshot Notifier",
		["dgks_RaidVersionCheckRequest"] = "dG Killshot Notifier",
		["dgks_GuildVersionCheckRequest"] = "dG Killshot Notifier",
		["dgks_VersionCheckResponse"] = "dG Killshot Notifier",
	["DPM"] = "Deadly Pvp Mods",
		["DPMcheck"] = "Deadly Pvp Mods",
		["DPMversion"] = "Deadly Pvp Mods",
		["DPMtrue"] = "Deadly Pvp Mods",
	["DQT"] = "DaylieQuestViewer",
	["DTM"] = "DiamondThreatMeter",
	["DRA2"] = "DruidRaidAssist2",
		["DRA2_ASK"] = "DruidRaidAssist2",
	["DXE"] = "Deus Vox Encounters",
		["DXE_Dist8"] = "Deus Vox Encounters",
	["EPGPLMVChk"] = "EPGPLootmaster",
		["EPGPLMVRsp"] = "EPGPLootmaster",
		["EPGPLMVHdlr"] = "EPGPLootmaster",
	["ExaminerGlyphs"] = "Examiner",
	["eXtremeRaid"] = "OnRaid",
	["FBAM"] = "Fishing Buddy",
	["GathX"] = "Gatherer",
	["GearScore"] = "GearScore",
		["GearScoreRecount"] = "GearScore",
		["GearScore_Request"] = "GearScore",
		["GearScore_Send"] = "GearScore",
		["GearScore_Version"] = "GearScore",
--		GSCR = not GearScore :(
		["GSY"] = "GearScore",
		["GSY_Request"] = "GearScore",
		["GSY_Version"] = "GearScore",
		["GSX"] = "GearScore",
	["GLDR"] = "Guilder",
	["GMSD"] = "GatherMate Sharing",
	["GoGoMountVER"] = "GoGoMount",
	["gqAccept"] = "Guild Quests",
		["gqLogout"] = "Guild Quests",
		["gqRemove"] = "Guild Quests",
		["gqReply"] = "Guild Quests",
	["GC3"] = "GroupCalendar",
		["GC3/"] = "GroupCalendar",  -- Does this one actually get sent?
		["GC4"] = "GroupCalendar",
		["GC4/"] = "GroupCalendar",  -- Does this one actually get sent?
	["GC5"] = "GroupCalendar",
	["GDALootlist"] = "GetDKP",
	["GLDG"] = "GuildGreet",
	["GEM3"] = "GuildEventManager",
	["GTH"] = "Getting Things Healed",
	["GuildCraft3"] = "Guild Craft",
	["GuildCraft35"] = "Guild Craft",
	["GuildSpyVersion"] = "GuildSpy",
	["GupPetVersion"] = "GupPet",
	["HealBot"] = "HealBot",
		["HealBot_GUID"] = "HealBot",
		["hbComms"] = "HealBot_Ultra_low_comms",
		["hbGUID"] = "HealBot",
		["HealBot_Heals"] = "HealBot",
	["HealComm"] = "LibHealComm-3.0",-- or version2, you cant tell them apart
	["HIVE"] = "HiveMind",
	["IHL"] = "IncomingHealsLib-1.0",
	["JambaCommunicationsCommand"] = "Jamba", --multiboxing tool
	["KALIFCMSG"] = "Forecast",
	["KARMA"] = "Karma",
	["KHP_dragon"] = "Kalecgos Dual HP",
	["KHP_deamon"] = "Kalecgos Dual HP",
	["KLHALG"] = "KLHAlgalon", --check
	["KLHTM"] = "KLHThreatMeter",
	["LGP"] = "LibGuildPositions-1.0",
	["LHC40"] = "LibHealComm-4.0",
	["LibGroupTalents-1.0"] = "LibGroupTalents-1.0",
	["LockdownUpdate"] = "Lockdown",
		["Lockdown0005Hello"] = "Lockdown",
		["Lockdown0005NewLock"] = "Lockdown",
		["Lockdown0005Wipe"] = "Lockdown",
	["LOOT_OPENED"] = "AceEvent-2.0 [Loot Opened]",
	["LPH10"] = "LibPendingHeals-1.0",
	["LRW2"] = "LiveRaidWatch_v2",
	["LVBM"] = "Deadly Boss Mods",
		["LVBM NSP"] = "Deadly Boss Mods",
		["LVFH MARK"] = "Deadly Boss Mods",
		["LVGWF ENRAGE"] = "Deadly Boss Mods",
		["LVFH VOID"] = "Deadly Boss Mods",
		["LVBM NSP"] = "Deadly Boss Mods",
		["LVNEF"] = "Deadly Boss MOds",
	["MLRA"] = "CT_RaidTracker",
	["MS1"] = "MinnaStats",
	["MagicMarker"] = "MagicMarker",
		["MagicMarkerRT"] = "MagicMarker",
	["MeBO"] = "MessageBoard", --most likely
	["mmkocomm"] = "MM Kill Order",--check!	 
	["MorgDKP2MorgBid"] = "MorgDKP2",
	["MorgDKP2Syncing"] = "MorgDKP2",
	["MorgDKP2MorgBid"] = "MorgDKP2",
	["MorgBid2"] = "MorgBid2",
	["MYC"] = "MakeYourChoice",
	["NECB"] = "Natur EnemyCastBar",
		["NECBCHAT"] = "Natur EnemyCastBar",
		["NECBCTRA"] = "Natur EnemyCastBar",
	["Nurfed:Lyt"] = "Nurfed Layout",
	["oRA"] = "oRA2",
	["oRA3"] = "oRA3",
	["<<PiraCore>>"] = "PiraMod",
	["Pit"] = "PitBull",
	["PALB"] = "Paladin Buffer",
	["PLPWR"] = "PallyPower",
	["Quecho"] = "Quecho",
		["Quecho2"] = "Quecho", --turned in
		["Quecho3"] = "Quecho", --accepted
	["QHpr"] = "QuestHelper",
	["QuGu"] = "Quest Guru",
	["Quixote2"] ="Kemayos Questlib (Libquixote-2.0)",
	["R\195\159"] = "RecipeBook",
	["RaCD"] = "RaidCooldowns",
	["RaidForge"] = "RaidForge",
	["RAIDTOTEMS"] = "TotemTimers",
	["RBM"] = "RBM",
	["RCD2"] = "RaidCooldowns",
	["RD"] = "RogueDamage",
	["RDX"] = "OpenRDX",
	["RID"] = "Raid ID",
	["SRA"] = "SRA",
	["RTM"] = "RezzTextMonitor",
	["SGLC"] = "SurgeonGeneral",
	["SRTi"] = "Simple Raid Target Icons",
	["SSAF"] = "SSArena Frames",
	["StinkyQ"] = "StinkyQueue",
	["Super Duper Macro query"] = "Super Duper Macro",
		["Super Duper Macro recFailed"] = "Super Duper Macro",
		["Super Duper Macro receiving"] = "Super Duper Macro",
		["Super Duper Macro sendFailed"] = "Super Duper Macro",
		["Super Duper Macro recDone"] = "Super Duper Macro",
		["Super Duper Macro response"] = "Super Duper Macro",
		["Super Duper Macro send1"] = "Super Duper Macro",
		["Super Duper Macro send2"] = "Super Duper Macro",
	["SWSudX21"] = "SW_Stats",
		["SWSHSX21"] = "SW_Stats",
		["SWSudX22"] = "SW_Stats",
		["SWSHSX22"] = "SW_Stats",
		["SWSVC7w7"] = "SW_Stats",
	["TAL"] = "LibRockComm-1.0",
		["UnT"] = "LibRockComm-1.0",
		["VER"] = "LibRockComm-1.0",
	["Talented"] = "Talented",
	["TGuide"] = "Tourguide",
	["Thr"] = "Threat-1.0",
	["TitanWG"] = "Titan Panel [Wintergrasp]",
	["TL2"] = "Threat-2.0",
	["TotemTracker"] = "TotemTracker",
	["tradeDispenser"] = "Trade Dispenser",
	["TSK"] = "TeamSqueak",
	["TypI"] = "TypingNotifier",
	["Utopia"] = "Utopia",
		["Utopia_UpTime"] = "Utopia",
	["VisualHeal"] = "VisualHeal",
	["VA"] = "VoidReaverAlarm",--version check answer
		["VC"] = "VoidReaverAlarm", --version check request
		["CB"] = "VoidReaverAlarm", --10sec normal mode
		["CT"] = "VoidReaverAlarm",--60sec test mode
	["VodkaHoldem"] = "WoWTexasHoldem",
	["WGA"] = "Wintergrasper Advanced",
	["WGFU"] = "WintergraspFU",
	["WGTime"] = "Capping", --Wintergrasp-Sync
	["WIM"] = "WoW Instant Messenger",
		["WIM_W2W"] = "WoW Instant Messenger",
	["WintergraspT"] = "WinterTime",
	["WL_LOOT_COOLDOWN"] = "Wowhead Looter",  
	["WL_LOOTCOOLDOWN_NPC"] = "Wowhead Looter",
	["WL_LOOTCOOLDOWN_OBJECT"] = "Wowhead Looter",
	["WL_LOOTED_NPC"]  = "Wowhead Looter",
	["WQ2"] = "WoWQuote2",
	["WRUGSAUTH"] = "WRUGS Anti-Spam",
	["YRT2"] = "YamRaidTracker2",
}